/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.MapObjekModulToKelompokUser;
import com.portofolio.entity.vo.MapObjekModulToKelompokUserId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface MapObjekModulToKelompokUserDao
		extends CrudRepository<MapObjekModulToKelompokUser, MapObjekModulToKelompokUserId> {

	@Cacheable("MapObjekModulToKelompokUserDaofindOneBy")
	MapObjekModulToKelompokUser findOneByIdKdKelompokUserAndIdKdObjekModulAplikasiAndIdKdProfile(Integer kdKelompokUser,
			String kdObjekModulAplikasi, Integer kdProfile);

	@Query(QListAll)
	@Cacheable("MapObjekModulToKelompokUserDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page);

	@Query(QListAll + " and model.id.kdKelompokUser = :kdKelompokUser ")
	@Cacheable("MapObjekModulToKelompokUserDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("kdKelompokUser") Integer kdKelompokUser, Pageable page);

	@Query(QListAll + " and model.id.kdKelompokUser = :kdKelompokUser")
	@Cacheable("MapObjekModulToKelompokUserDaoFindByKode")
	List<Map<String, Object>> findByKode(@Param("kdProfile") Integer kdProfile,
			@Param("kdKelompokUser") Integer kdKelompokUser);

	String QListAll = "select new map(model.id as kode , model.simpan as simpan , model.hapus as hapus "
			+ ", model.ubah as ubah , model.cetak as cetak , model.tampil as tampil "
			+ ", model.statusEnabled as statusEnabled , model.noRec as noRec, model.version as version"
			+ ", objekModulAplikasi.namaObjekModulAplikasi as namaObjekModulAplikasi )"
			+ " from MapObjekModulToKelompokUser model left join model.id id left join model.profile profile "
			+ " left join model.objekModulAplikasi objekModulAplikasi where model.id.kdProfile =:kdProfile  and model.statusEnabled = true  ";

	@Modifying
	@Cacheable("setStatusEnabledFalseDao")
	// @Transactional
	@Query("update MapObjekModulToKelompokUser model "
			+ " set model.ubah=0 , model.cetak=0 , model.tampil=0 , model.hapus=0 , model.simpan=0 "
			+ " where model.id.kdProfile =:kdProfile and model.id.kdKelompokUser =:kdKelompokUser")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile,
			@Param("kdKelompokUser") Integer kdKelompokUser);

	@Cacheable("countIdKdKelompokUserByIdKdKelompokUserAndIdKdProfileDao")
	Long countIdKdKelompokUserByIdKdKelompokUserAndIdKdProfile(Integer kdKelompokUser, Integer kdProfile);

	@Query("select new map(model.id.kdObjekModulAplikasi as kdObjekModulAplikasi,  model.simpan as simpan , model.hapus as hapus "
			+ ", model.ubah as ubah , model.cetak as cetak , model.tampil as tampil "
			+ ", model.statusEnabled as statusEnabled ,objekModulAplikasi.namaObjekModulAplikasi as namaObjekModulAplikasi )"
			+ " from MapObjekModulToKelompokUser model left join model.objekModulAplikasi objekModulAplikasi"
			+ " where model.id.kdProfile =:kdProfile and model.id.kdObjekModulAplikasi=:kdObjekModulAplikasi "
			+ " and model.statusEnabled = true and model.id.kdKelompokUser =:kdKelompokUser")
	Map<String, Object> findByProfileKdObj(@Param("kdProfile") Integer kdProfile,
			@Param("kdObjekModulAplikasi") String kdObjekModulAplikasi,
			@Param("kdKelompokUser") Integer kdKelompokUser);
}
